// Program tworzy trzech kolejnych potomkow, wykonujacych kolejno 
// polecenia: cp PLIK PLIK.tmp; sort PLIK.tmp -o wynik;
// cat wynik, nazwa PLIK przekazywana programowi jako argument wywolania 
// (c) Kacper Kulczycki 2006
// ************************************************************************** 
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <string.h>
#include "err.h"
// ***************************************************************************
int main(int argc, char *argv[])
{
  int src, indx, tmp, dst;
  pid_t pid;
  if (argc != 2) 
	{
	fatal("Brak zdefiniowanych parametrow dla %s", argv[0]);
	}
  char temp[4096];
  //temp=strdup(argv[1]);	
  strcpy(temp,argv[1]); // nistety okazalo sie ze strdup nie dzila poprawnie
  strcat(temp,".tmp"); // w zestawieniu z strcat ! bardzo dziwne !
  printf("nazwa tymczasowa: %s\n", temp);
  //  proces sie przedstawia: 
  printf("Jestem procesem o PID = %d\n", getpid());
  for(indx=0; indx<3;indx++) // tworzenie potomkow:
	{
	printf("fork'uje po raz %d.\n", indx+1);
	switch(pid=fork())
		{ 			
    		case -1:    
      			syserr("Cos nie tak w fork!!!\n"); // gdy blad
    		case 0: // gdy potomek
			{
      			printf("Jestem potomkiem o PID = %d\n", getpid());
			if(indx>1&&indx<3)
				{
 				if((src=access(argv[1],F_OK | R_OK))<0)
        				{
        				syserr("Bledna nazwa pliku zrodlowego: %s", argv[1]);
        				}
				printf("nazawy dla cp: %s %s\n",argv[1],temp);
				if((tmp = open(temp, O_CREAT | O_TRUNC | O_WRONLY, 0644))<0)
        				{
        				syserr("Blad podczas otwierania pliku %s", temp);
        				}
				printf("PID = %d: cp %s %s\n", getpid(), argv[1], temp);
                               	execlp("cp","cp", argv[1], temp, NULL);
				syserr("Cos nie tak z cp!!!\n");
				}
			break;
			}
		default: // gdy proces jest procesem macierzystym
			printf("Jestem rodzicem o PID = %d\n", getpid());
      			printf("Wartosc PID mojego potomka = %d\n", pid);
			printf("czekam na proces o PID = %d\n", pid);
			if (wait(0) == -1) 
       				{
					syserr("Cos nie tak w wait!!!\n");
				}
			switch(indx)
				{
				case 1:
					{
                              		if((dst = access("wynik", F_OK | R_OK))<0)
                                      		{
                                      		syserr("Blad podczas otwierania pliku %s", "wynik");
                                      		}
					printf("PID = %d: cat %s\n",getpid(),"wynik");
                              		execlp("cat","cat","wynik", NULL);
                                      	syserr("Cos nie tak z cat!!!\n");
                              		}
		 		case 2:
                                	{
                                	if((tmp = access(temp, F_OK | R_OK))<0)
                                        	{
                                        	syserr("Blad podczas otwierania pliku %s",temp);
                                        	}
                                	if((dst = open("wynik", O_CREAT | O_TRUNC | O_WRONLY, 0644))<0)
                                        	{
                                        	syserr("Blad podczas otwierania pliku %s","wynik");
                                        	}
					printf("PID = %d: sort %s -o %s\n",getpid(),temp,"wynik");
                                	execlp("sort","sort",temp,"-o","wynik",NULL);
                                        syserr("Cos nie tak z sort!!!\n");
                                	}
				}
		exit(0);
		}
	}
exit(0);
}

